import { system, world, EquipmentSlot, EntityEquippableComponent, Player } from "@minecraft/server";

export const shieldChargeLocked = "hax:shield_charge_locked";
export const getObjective = (id) => world.scoreboard.getObjective(id) ?? world.scoreboard.addObjective(id, id);

export function getEquipment(player) {
  const tick = system.currentTick;
  if (player._equip?.tick === tick) return player._equip.comp;
  const comp = player.getComponent(EntityEquippableComponent.componentId);
  player._equip = { tick, comp };
  return comp;
}

//export function getEquipment(player) {
//  if (player._equip) return player._equip;
//  const comp = player.getComponent(EntityEquippableComponent.componentId);
//  player._equip = comp;
//  return comp;
//}

export const classTests = [
    ["_hoe", "_dagger", "_nunchaku"], //7 [8] swift
    ["_pickaxe", "_sai"], //12 light
    ["_axe", "_shovel", "trident", "_cleaver", "_kama", "_khopesh"], //20 [16] medium
    ["minecraft:mace", "shield", "_mace", "_spade"], //25 heavy
    ["_battleaxe", "_morningstar"], //30 extreme
    ["_gladius", "_katana"], //7 [8] swift
    ["_sword", "_broadsword", "_cutlass", "_scimitar"], //12 light
    ["_machete", "_longsword"], //20 [16] medium
    ["_claymore"], //25 heavy
    ["_greatsword", "_scythe"], //30 extreme
    //special weapons
    ["_lance"], ["_rapier"], ["_hammer"], //["_cleaver"],
];

// TODO: unused for now, create tag list for items
// export const tagTests = [
  // ["_hoe", "_dagger", "_kama", "_nunchaku", "_sai"], //7 swift
  // ["_pickaxe", "_cleaver"], //12 light
  // ["_axe", "_shovel", "trident", "_khopesh"], //20 medium
  // ["_spade", "shield"], //25 heavy
  // ["_battleaxe"], //30 extreme
  // ["_gladius", "_katana"], //7 swift
  // ["_sword", "_broadsword", "_cutlass", "_scimitar"], //12 light
  // ["_claymore", "_longsword", "_mace"], //20 medium
  // ["_machete", "_scythe"], //25 heavy
  // ["_greatsword", "_morningstar"], //30 extreme
    // special weapons
  // ["_lance"], ["_rapier"], ["_hammer"], //["_cleaver"],
// ];

export const cooldownMap = {
    0: 4, 1: 8, 2: 12,
    3: 16, 4: 25, 5: 30,
    6: 8, 7: 12, 8: 16,
    9: 25, 10: 30,
    //special weapons
    11: 12, 12: 8, 13: 25, //14: 12, /*15: 30,*/
};

export const commandMap = {
    6: 'htc_sweep_light',
    7: 'htc_sweep_light',
    8: 'htc_sweep_medium',
    9: 'htc_sweep_heavy',
    10: 'htc_sweep_extreme',
    //11: 'htc_stab_large',
    13: 'htc_shockwave',
};

export const standardMap = [6, 7, 8, 9, 10];

export const displayMap = {
    1: '', 2: '', 3: '', 4: '', 5: '',
    6: '', 7: '', 8: '', 9: '', 10: '',
    11: '', 12: '', 13: '', 14: '', 15: '',
    16: '', 17: '', 18: '', 19: '', 20: '',
    21: '', 22: '', 23: '', 24: '', 25: '',
    26: '', 27: '', 28: '', 29: '',
};

export const chargeMap = {
  2: '§r§8||||||||§r', 3: '§r§8||||||||§r', 4: '§r§7|§8|||||||§r', 5: '§r§4|§7|§8||||||§r', 6: '§r§4|§6|§7|§8|||||§r', 7: '§r§4|§6||§7|§8||||§r',
  8: '§r§4|§6||§e|§7|§8|||§r', 9: '§r§4|§6||§e||§7|§8||§r', 10: '§r§4|§6||§e|||§7|§8|§r', 11: '§r§4|§6||§e|||§a|§7|§r', 12: '§r§4|§6||§e|||§a|§b|§r',
};


let playersCache;
export function getPlayers() {
  const tick = system.currentTick;
  if (playersCache?.tick === tick) return playersCache.players;
  const players = world.getPlayers();
  playersCache = { tick, players };
  return players;
}